//////////////////////////////////////////////////////////
//   This class has been automatically generated 
//     (Tue May 13 16:34:01 2003 by ROOT version3.05/05)
//   from TTree h2000/run
//   found on file: emec_12369.root
//////////////////////////////////////////////////////////


#ifndef EmecRunHeader2002v0_h
#define EmecRunHeader2002v0_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <string>
#include <iostream>

using std::string;
using std::cout;
using std::endl;

/*! - Class EmecRunHeader2002v0
  * - Author: Ian Gable (igable@uvic.ca)
  * - Date:  05/27/2003
  * - Description: This class was created by root 3.05/05. Use it to access the information
  *      contained in the Emec Run Header.
  */

class EmecRunHeader2002v0 {
  public :
  TTree          *fChain;   //!pointer to the analyzed TTree or TChain
  Int_t           fCurrent; //!current Tree number in a TChain
  
  
  
  //! first FEB channel number
  UInt_t getFirstCh(){ return first_ch;};
  
  //! last FEB channel number
  UInt_t getLastCh(){ return last_ch;};
  
  //! peak finding method (polynomial=1, digital filtering=2)
  Int_t peakMethod() {return peakf; };
  
  //! cal Version number of calibration file (if digital filtering is used)
  UInt_t calVersion(){return cal_version;};
  
  //! Version number of weight parameters files (if digital filtering is used)
  UInt_t digVersion(){return dig_version;};
  
  //! Shower model type ("0" for real data)
  UInt_t getShower(){return shower;};
  
  //! Unit of energy (ADC=1, nA=2)
  UInt_t getEUnit(){return eunit;};
  
  //! The number of adc channels
  Int_t getCellsUsed(){return cells_used;};
  
  Float_t getPedRms(int febno){
    if(febno >= getFirstCh() && febno <= getLastCh() ){
      return ped_rms[febno];
    } else {
      cout << "Ped RMS accessed out of bounds at: " << febno <<endl;
      exit(1);
    }
  }
  
  //! the global timing type (<= 0 is TDC, >0 is cubic)
  UInt_t getTimingType() { return timing_type;};
  
  //! return the name of the data file read in.
  string getDataFileName(){ return m_fileName;};
  
  void setDataFileName(string fileName){ m_fileName =fileName;};
  
  //private:
  
  //Declaration of leaves types
  string m_fileName;
  UInt_t          first_ch;
  UInt_t          last_ch;
  Int_t           peakf;
  UInt_t          cal_version;
  UInt_t          dig_version;
  UInt_t          shower;
  UInt_t          eunit;
  Int_t           cells_used;
  Float_t         ped_rms[1152];   //[cells_used]
  Int_t           ieta[1152];   //[cells_used]
  Int_t           iphi[1152];   //[cells_used]
  Int_t           iz[1152];   //[cells_used]
  Int_t           ieta_atlas[1152];   //[cells_used]
  Int_t           iphi_atlas[1152];   //[cells_used]
  Int_t           iz_atlas[1152];   //[cells_used]
  Float_t         Signalovernoise_cut;
  Float_t         Resolutioncoeffa;
  Float_t         Resolutioncoeffb;
  Int_t           Timehec_sample_low;
  Float_t         Timehec_low_signal_cut;
  Float_t         Timehec_int_signal_scale;
  Float_t         Timehec_int_signal_dt;
  Int_t           Timeemec_sample_low;
  Float_t         Timeemec_low_signal_cut;
  Float_t         Timeemec_int_signal_scale;
  Float_t         Timeemec_int_signal_dt;
  UInt_t          timing_type;
  Float_t         t0_dig;
  Float_t         t0_cub_c;
  Float_t         t0_cub_epi;
  Float_t         t0_cub_mu;
  Int_t           t0_cub_trig;
  Int_t           tdc_wac_c;
  Int_t           tdc_wac_epi;
  Int_t           tdc_wac_mu;
  Int_t           tdc_wac_reference;
  UInt_t          tdc_guard_region;
  Int_t           tdc_force_wac;
  Int_t           sample_low;
  Float_t         low_signal_cut;
  Float_t         int_signal_scale;
  Float_t         int_signal_dt;
  
  //List of branches
  TBranch        *b_first_ch;   //!
  TBranch        *b_last_ch;   //!
  TBranch        *b_peakf;   //!
  TBranch        *b_cal_version;   //!
  TBranch        *b_dig_version;   //!
  TBranch        *b_shower;   //!
  TBranch        *b_eunit;   //!
  TBranch        *b_cells_used;   //!
  TBranch        *b_ped_rms;   //!
  TBranch        *b_ieta;   //!
  TBranch        *b_iphi;   //!
  TBranch        *b_iz;   //!
  TBranch        *b_ieta_atlas;   //!
  TBranch        *b_iphi_atlas;   //!
  TBranch        *b_iz_atlas;   //!
  TBranch        *b_Signalovernoise_cut;   //!
  TBranch        *b_Resolutioncoeffa;   //!
  TBranch        *b_Resolutioncoeffb;   //!
  TBranch        *b_Timehec_sample_low;   //!
  TBranch        *b_Timehec_low_signal_cut;   //!
  TBranch        *b_Timehec_int_signal_scale;   //!
  TBranch        *b_Timehec_int_signal_dt;   //!
  TBranch        *b_Timeemec_sample_low;   //!
  TBranch        *b_Timeemec_low_signal_cut;   //!
  TBranch        *b_Timeemec_int_signal_scale;   //!
  TBranch        *b_Timeemec_int_signal_dt;   //!
  TBranch        *b_timing_type;   //!
  TBranch        *b_t0_dig;   //!
  TBranch        *b_t0_cub_c;   //!
  TBranch        *b_t0_cub_epi;   //!
  TBranch        *b_t0_cub_mu;   //!
  TBranch        *b_t0_cub_trig;   //!
  TBranch        *b_tdc_wac_c;   //!
  TBranch        *b_tdc_wac_epi;   //!
  TBranch        *b_tdc_wac_mu;   //!
  TBranch        *b_tdc_wac_reference;   //!
  TBranch        *b_tdc_guard_region;   //!
  TBranch        *b_tdc_force_wac;   //!
  TBranch        *b_sample_low;   //!
  TBranch        *b_low_signal_cut;   //!
  TBranch        *b_int_signal_scale;   //!
  TBranch        *b_int_signal_dt;   //!
  
  EmecRunHeader2002v0(TTree *tree=0,string fileName=0);
  ~EmecRunHeader2002v0();
  Int_t  Cut(Int_t entry);
  Int_t  GetEntry(Int_t entry);
  Int_t  LoadTree(Int_t entry);
  void   Init(TTree *tree);
  void   Loop();
  Bool_t Notify();
  void   Show(Int_t entry = -1);
};

#endif

#ifdef EmecRunHeader2002v0_cxx
EmecRunHeader2002v0::EmecRunHeader2002v0(TTree *tree,string fileName)
{
  // if parameter tree is not specified (or zero), connect the file
  // used to generate this class and read the Tree.
  TFile *f ;
  if (tree == 0) {
    f = new TFile(fileName.c_str());
    
    tree = (TTree*)f->Get("h2000");
    
  }
  Init(tree);
}

EmecRunHeader2002v0::~EmecRunHeader2002v0()
{
  if (!fChain) return;
  delete fChain->GetCurrentFile();
}

Int_t EmecRunHeader2002v0::GetEntry(Int_t entry)
{
  // Read contents of entry.
  if (!fChain) return 0;
  return fChain->GetEntry(entry);
}
Int_t EmecRunHeader2002v0::LoadTree(Int_t entry)
{
  // Set the environment to read one entry
  if (!fChain) return -5;
  Int_t centry = fChain->LoadTree(entry);
  if (centry < 0) return centry;
  if (fChain->IsA() != TChain::Class()) return centry;
  TChain *chain = (TChain*)fChain;
  if (chain->GetTreeNumber() != fCurrent) {
    fCurrent = chain->GetTreeNumber();
    Notify();
  }
  return centry;
}

void EmecRunHeader2002v0::Init(TTree *tree)
{
  //   Set branch addresses
  if (tree == 0) return;
  fChain    = tree;
  fCurrent = -1;
  fChain->SetMakeClass(1);
  
  fChain->SetBranchAddress("first_ch",&first_ch);
  fChain->SetBranchAddress("last_ch",&last_ch);
  fChain->SetBranchAddress("peakf",&peakf);
  fChain->SetBranchAddress("cal_version",&cal_version);
  fChain->SetBranchAddress("dig_version",&dig_version);
  fChain->SetBranchAddress("shower",&shower);
  fChain->SetBranchAddress("eunit",&eunit);
  fChain->SetBranchAddress("cells_used",&cells_used);
  fChain->SetBranchAddress("ped_rms",ped_rms);
  fChain->SetBranchAddress("ieta",ieta);
  fChain->SetBranchAddress("iphi",iphi);
  fChain->SetBranchAddress("iz",iz);
  fChain->SetBranchAddress("ieta_atlas",ieta_atlas);
  fChain->SetBranchAddress("iphi_atlas",iphi_atlas);
  fChain->SetBranchAddress("iz_atlas",iz_atlas);
  fChain->SetBranchAddress("Signalovernoise_cut",&Signalovernoise_cut);
  fChain->SetBranchAddress("Resolutioncoeffa",&Resolutioncoeffa);
  fChain->SetBranchAddress("Resolutioncoeffb",&Resolutioncoeffb);
  fChain->SetBranchAddress("Timehec_sample_low",&Timehec_sample_low);
  fChain->SetBranchAddress("Timehec_low_signal_cut",&Timehec_low_signal_cut);
  fChain->SetBranchAddress("Timehec_int_signal_scale",&Timehec_int_signal_scale);
  fChain->SetBranchAddress("Timehec_int_signal_dt",&Timehec_int_signal_dt);
  fChain->SetBranchAddress("Timeemec_sample_low",&Timeemec_sample_low);
  fChain->SetBranchAddress("Timeemec_low_signal_cut",&Timeemec_low_signal_cut);
  fChain->SetBranchAddress("Timeemec_int_signal_scale",&Timeemec_int_signal_scale);
  fChain->SetBranchAddress("Timeemec_int_signal_dt",&Timeemec_int_signal_dt);
  fChain->SetBranchAddress("timing_type",&timing_type);
  fChain->SetBranchAddress("t0_dig",&t0_dig);
  fChain->SetBranchAddress("t0_cub_c",&t0_cub_c);
  fChain->SetBranchAddress("t0_cub_epi",&t0_cub_epi);
  fChain->SetBranchAddress("t0_cub_mu",&t0_cub_mu);
  fChain->SetBranchAddress("t0_cub_trig",&t0_cub_trig);
  fChain->SetBranchAddress("tdc_wac_c",&tdc_wac_c);
  fChain->SetBranchAddress("tdc_wac_epi",&tdc_wac_epi);
  fChain->SetBranchAddress("tdc_wac_mu",&tdc_wac_mu);
  fChain->SetBranchAddress("tdc_wac_reference",&tdc_wac_reference);
  fChain->SetBranchAddress("tdc_guard_region",&tdc_guard_region);
  fChain->SetBranchAddress("tdc_force_wac",&tdc_force_wac);
  fChain->SetBranchAddress("sample_low",&sample_low);
  fChain->SetBranchAddress("low_signal_cut",&low_signal_cut);
  fChain->SetBranchAddress("int_signal_scale",&int_signal_scale);
  fChain->SetBranchAddress("int_signal_dt",&int_signal_dt);
  Notify();
}

Bool_t EmecRunHeader2002v0::Notify()
{
  // Called when loading a new file.
  // Get branch pointers.
  b_first_ch = fChain->GetBranch("first_ch");
  b_last_ch = fChain->GetBranch("last_ch");
  b_peakf = fChain->GetBranch("peakf");
  b_cal_version = fChain->GetBranch("cal_version");
  b_dig_version = fChain->GetBranch("dig_version");
  b_shower = fChain->GetBranch("shower");
  b_eunit = fChain->GetBranch("eunit");
  b_cells_used = fChain->GetBranch("cells_used");
  b_ped_rms = fChain->GetBranch("ped_rms");
  b_ieta = fChain->GetBranch("ieta");
  b_iphi = fChain->GetBranch("iphi");
  b_iz = fChain->GetBranch("iz");
  b_ieta_atlas = fChain->GetBranch("ieta_atlas");
  b_iphi_atlas = fChain->GetBranch("iphi_atlas");
  b_iz_atlas = fChain->GetBranch("iz_atlas");
  b_Signalovernoise_cut = fChain->GetBranch("Signalovernoise_cut");
  b_Resolutioncoeffa = fChain->GetBranch("Resolutioncoeffa");
  b_Resolutioncoeffb = fChain->GetBranch("Resolutioncoeffb");
  b_Timehec_sample_low = fChain->GetBranch("Timehec_sample_low");
  b_Timehec_low_signal_cut = fChain->GetBranch("Timehec_low_signal_cut");
  b_Timehec_int_signal_scale = fChain->GetBranch("Timehec_int_signal_scale");
  b_Timehec_int_signal_dt = fChain->GetBranch("Timehec_int_signal_dt");
  b_Timeemec_sample_low = fChain->GetBranch("Timeemec_sample_low");
  b_Timeemec_low_signal_cut = fChain->GetBranch("Timeemec_low_signal_cut");
  b_Timeemec_int_signal_scale = fChain->GetBranch("Timeemec_int_signal_scale");
  b_Timeemec_int_signal_dt = fChain->GetBranch("Timeemec_int_signal_dt");
  b_timing_type = fChain->GetBranch("timing_type");
  b_t0_dig = fChain->GetBranch("t0_dig");
  b_t0_cub_c = fChain->GetBranch("t0_cub_c");
  b_t0_cub_epi = fChain->GetBranch("t0_cub_epi");
  b_t0_cub_mu = fChain->GetBranch("t0_cub_mu");
  b_t0_cub_trig = fChain->GetBranch("t0_cub_trig");
  b_tdc_wac_c = fChain->GetBranch("tdc_wac_c");
  b_tdc_wac_epi = fChain->GetBranch("tdc_wac_epi");
  b_tdc_wac_mu = fChain->GetBranch("tdc_wac_mu");
  b_tdc_wac_reference = fChain->GetBranch("tdc_wac_reference");
  b_tdc_guard_region = fChain->GetBranch("tdc_guard_region");
  b_tdc_force_wac = fChain->GetBranch("tdc_force_wac");
  b_sample_low = fChain->GetBranch("sample_low");
  b_low_signal_cut = fChain->GetBranch("low_signal_cut");
  b_int_signal_scale = fChain->GetBranch("int_signal_scale");
  b_int_signal_dt = fChain->GetBranch("int_signal_dt");
  return kTRUE;
}

void EmecRunHeader2002v0::Show(Int_t entry)
{
  // Print contents of entry.
  // If entry is not specified, print current entry
  if (!fChain) return;
  fChain->Show(entry);
}
Int_t EmecRunHeader2002v0::Cut(Int_t entry)
{
  // This function may be called from Loop.
  // returns  1 if entry is accepted.
  // returns -1 otherwise.
  return 1;
}
#endif // #ifdef EmecRunHeader2002v0_cxx

