
#include "SystemAlg.h"

#include <sstream>
#include <string>



SystemAlg::SystemAlg(Event* event, Geometry* geo, Headers* runHeader){
  m_event = event;
  m_geo = geo;
  m_runHeader = runHeader;
}

// call the destructors of all the SystemAlgs in the algVector
SystemAlg::~SystemAlg(){
  for(vector<SystemAlg*>::iterator itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    delete (*itr);
  }
}

void SystemAlg::setAlgs(vector<SystemAlg*> algs){
  m_algVector = algs;
}

// initialize any variables here
bool SystemAlg::initialize(){

  for(vector<SystemAlg*>::iterator itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    (*itr)->initialize();
  }

  return true;
}

// put any code you want executed per event here
bool SystemAlg::execute(){

  for(vector<SystemAlg*>::iterator itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    (*itr)->execute();
  }

  return true;
}


bool SystemAlg::finalize(){

  for(vector<SystemAlg*>::iterator itr = m_algVector.begin(); itr != m_algVector.end(); itr++){
    (*itr)->finalize();
  }
  return true;
}
