
#include "UserAlg.h"
#include "RunStatisticsAlg.h"

#include <sstream>
#include <string>

using std::cout;
using std::endl;
using std::vector;
using std::string;

UserAlg::UserAlg(Event* event, Geometry* geo, Headers* runHeader):SystemAlg( event,geo,runHeader){
  m_event = event;
  m_geo = geo;
  m_runHeader = runHeader;

  m_noise = new NoiseAlg(m_event, m_geo, m_runHeader);
  RunStatisticsAlg* runstatistics = new RunStatisticsAlg(m_event, m_geo, m_runHeader);
  vector<SystemAlg*> algVector;

  algVector.push_back(m_noise);
  algVector.push_back(runstatistics);
  SystemAlg::setAlgs(algVector);
}

// initialize any variables here
bool UserAlg::initialize(){
  SystemAlg::initialize(); //do NOT remove this line

  return true;
}

// put any code you want executed per event here
bool UserAlg::execute(){
  SystemAlg::execute(); //do NOT remove this line

  return true;
}

//put any code here that you want executed after all the events have been processed.
bool UserAlg::finalize(){
  SystemAlg::finalize();//do NOT remove this line

  return true;
}
